'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _nivo = require('nivo');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var margin = { top: 20, right: 30, bottom: 40, left: 60 };
var format = function format(d) {
    return (0, _moment2.default)(d).format('MM/DD');
};

var RepoTrafficViewsLineChart = function (_Component) {
    _inherits(RepoTrafficViewsLineChart, _Component);

    function RepoTrafficViewsLineChart() {
        _classCallCheck(this, RepoTrafficViewsLineChart);

        return _possibleConstructorReturn(this, (RepoTrafficViewsLineChart.__proto__ || Object.getPrototypeOf(RepoTrafficViewsLineChart)).apply(this, arguments));
    }

    _createClass(RepoTrafficViewsLineChart, [{
        key: 'render',
        value: function render() {
            var views = this.props.views;
            var theme = this.context.theme;


            return _react2.default.createElement(
                _nivo.ResponsiveChart,
                { margin: margin, data: views, theme: theme.charts },
                _react2.default.createElement(_nivo.Scale, { id: 'count', dataKey: 'count', type: 'linear', axis: 'y' }),
                _react2.default.createElement(_nivo.Scale, { id: 'timestamp', dataKey: 'timestamp', type: 'point', axis: 'x' }),
                _react2.default.createElement(_nivo.Grid, { xScale: 'timestamp', yScale: 'count' }),
                _react2.default.createElement(_nivo.Axis, { scaleId: 'timestamp', format: format, position: 'bottom' }),
                _react2.default.createElement(_nivo.Axis, { scaleId: 'count', position: 'left' }),
                _react2.default.createElement(_nivo.Line, { xScale: 'timestamp', x: 'timestamp', yScale: 'count', y: 'count', curve: 'linear' }),
                _react2.default.createElement(_nivo.Line, { xScale: 'timestamp', x: 'timestamp', yScale: 'count', y: 'uniques', curve: 'linear' })
            );
        }
    }]);

    return RepoTrafficViewsLineChart;
}(_react.Component);

RepoTrafficViewsLineChart.propTypes = {
    views: _react.PropTypes.array.isRequired
};
RepoTrafficViewsLineChart.contextTypes = {
    theme: _react.PropTypes.object.isRequired
};
exports.default = RepoTrafficViewsLineChart;